#include <iostream>
#include <cmath>

using namespace std;

#include "qf.cpp"

//funkcja f
double f(double x)
{
//	return cos(x);
	return x*x*x-3*x*x+2*x+1;
}

//jej pochodna
/*double f_p(double x)
{
	return sin(x);
}*/

//jej calka oznaczona na [a,b]
double f_I(double a,double b)
{
//	return sin(b)-sin(a);
	return b*b*b*b/4-3*b*b*b/3+2*b*b/2+b-(a*a*a*a/4-3*a*a*a/3+2*a*a/2+a);
}

QF<double> qf;

int main()
{
	int n=10;
	double S,I;
	double a=-1,b=1;
	double eps=0.00001;
	cout << "Podaj ilosc punktow: ";
	cin >> n;
	cout << "Podaj lewy koniec przedzialu calkowania: ";
	cin >> a;
	cout << "Podaj prawy koniec przedzialu calkowania: ";
	cin >> b;
	cout << "Podaj dokladnosc: ";
	cin >> eps;

	I=f_I(a,b);

	cout << "Prostokaty\n";
	S=qf.Rect(a,b,n,&f);
	cout << fixed << S << " " << I << " " << scientific << I-S << " " << (I-S)/I << "\n\n";

	cout << "Prostokaty eps="<< eps << "\n";
	S=qf.Rect(a,b,eps,&f);
	cout << fixed << S << " " << I << " " << scientific << I-S << " " << (I-S)/I << "\n";
	cout << "Ilosc uzytych wezlow:"<< qf.nelem << "\n\n";

	cout << "Trapezy\n";
	S=qf.Trapez(a,b,n,&f);
	cout << fixed << S << " " << I << " " << scientific << I-S << " " << (I-S)/I << "\n\n";

	cout << "Trapezy eps="<< eps << "\n";
	S=qf.Trapez(a,b,eps,&f);
	cout << fixed << S << " " << I << " " << scientific << I-S << " " << (I-S)/I << "\n";
	cout << "Ilosc uzytych wezlow:"<< qf.nelem << "\n\n";

	cout << "Simpson\n";
	S=qf.Simpson(a,b,n,&f);
	cout << fixed << S << " " << I << " " << scientific << I-S << " " << (I-S)/I << "\n\n";

	cout << "Simpson eps="<< eps << "\n";
	S=qf.Simpson(a,b,eps,&f);
	cout << fixed << S << " " << I << " " << scientific << I-S << " " << (I-S)/I << "\n";
	cout << "Ilosc uzytych wezlow:"<< qf.nelem << "\n\n";

	cout << "Newton\n";
	S=qf.Newton(a,b,n,&f);
	I=f_I(a,b);
	cout << fixed << S << " " << I << " " << scientific << I-S << " " << (I-S)/I << "\n\n";

	cout << "Newton eps="<< eps << "\n";
	S=qf.Newton(a,b,eps,&f);
	cout << fixed << S << " " << I << " " << scientific << I-S << " " << (I-S)/I << "\n";
	cout << "Ilosc uzytych wezlow:"<< qf.nelem << "\n\n";

	//tu przykladowe obliczanie pochodnej
	/*double x=a;
	if (n<1) n=2;
	double deltax=(b-a)/(n-1);
	double dx=0.001;
	int np=3;
	for (int i=0; i<n; i++)
	{
		cout << "x=" << x << " " << qf.Diff(x,dx,np,&f) << " " << f_p(x) << "\n";
		x=a+(double)i*deltax;
	}*/

	return 1;
}