#ifndef _QF_H_
#define _QF_H_

//typ T nie powinien byc int
template<class T>
class QF
{
public:
	int nelem;						//tu bedzie przechowywana ilosc punktow uzytych w ostatnio
									//przeprowadzonym calkowaniu

	typedef T (*RefFunc)(T);

	//znajduje n-ta pochodna funkcji w punkcie (wersja rekurencyjna, uproszczona)
	T Diff(T,T,int,RefFunc);

	//znajduje max. z n-ta pochodna funkcji na przedziale (uzywa Diff)
	T DiffMax(T,T,T,int,RefFunc);

	//metody 'na ilosc elementow'
	T Rect(T,T,int,RefFunc);		//calkowanie metoda prostokatow
	T Trapez(T,T,int,RefFunc);		//calkowanie metoda trapezow
	T Simpson(T,T,int,RefFunc);		//calkowanie metoda simpsona
	T Newton(T,T,int,RefFunc);		//calkowanie metoda newtona

	//metody 'na dokladnosc' (nie gwarantuje ich pelnej poprawnosci)
	T Rect(T,T,T,RefFunc);			//calkowanie metoda prostokatow
	T Trapez(T,T,T,RefFunc);		//calkowanie metoda trapezow
	T Simpson(T,T,T,RefFunc);		//calkowanie metoda simpsona
	T Newton(T,T,T,RefFunc);		//calkowanie metoda newtona

};

#endif